function getNum(num) {
  var number = num || 10;
  var list = [];
  for (var i = 0; i < number; i++) {
    list[i] = "#";
  }
  return list;
}

function randomNum(max, precision) {
  if (precision) {
    return parseFloat((max * Math.random()).toFixed(precision));
  } else {
    return parseInt(max * Math.random());
  }
}

var options = ["A", "B", "C", "D", "E", "F", "G", "#"];

var chartData = {
  basic_question: function(index, isObjective) {
    return {
      name: "填空题-" + (index + 1),
      number: index + 1,
      fullScore: 3,
      maxScore: 2,
      minScore: 0,
      avgScore: randomNum(3, 1),
      stdevScore: randomNum(3, 1),
      coefficient: randomNum(10, 1),
      difficulty: randomNum(1, 1),
      discrimination: randomNum(2, 1),
      totalCount: randomNum(100),
      zeroCount: randomNum(10),
      fullCount: randomNum(3),
      fullRate: isObjective ? randomNum(1, 1) : null,
      scoreRate: randomNum(1, 1)
    };
  },
  basic_class: function(index) {
    var prename =
      Math.random() > 0.5 ? "19三四五六七八九十一二" : "18工程造价本";
    return {
      name: prename + index,
      avgScore: randomNum(60),
      maxScore: randomNum(100),
      minScore: randomNum(30),
      stdevScore: randomNum(3, 1),
      excellentCount: randomNum(10),
      excellentRate: randomNum(1, 1),
      passCount: randomNum(20),
      passRate: randomNum(1, 1)
    };
  },
  basic_teacher: function(index) {
    return {
      name: "张小金-" + index,
      total: {
        avgScore: randomNum(60),
        maxScore: randomNum(100),
        minScore: randomNum(50),
        stdevScore: randomNum(3, 1),
        excellentCount: randomNum(10),
        excellentRate: randomNum(1, 1),
        passCount: randomNum(20),
        passRate: randomNum(1, 1),
        totalCount: randomNum(100),
        relativeAvgScore: randomNum(20) - 10
      }
    };
  },
  basic_teacher_class: function(index) {
    var prename = Math.random() > 0.5 ? "一二三四五六七八九十" : "城乡规划学院";
    return {
      name: prename + index,
      avgScore: randomNum(60),
      maxScore: randomNum(100),
      minScore: randomNum(50),
      stdevScore: randomNum(3, 1),
      excellentCount: randomNum(10),
      excellentRate: randomNum(1, 1),
      passCount: randomNum(20),
      passRate: randomNum(1, 1),
      totalCount: randomNum(100),
      relativeAvgScore: randomNum(10) - 20
    };
  },
  basic_college: function(index) {
    return {
      name: "汽车专修学院-" + index,
      avgScore: randomNum(60),
      maxScore: randomNum(100),
      minScore: randomNum(30),
      stdevScore: randomNum(3, 1),
      excellentCount: randomNum(10),
      excellentRate: randomNum(1, 1),
      passCount: randomNum(20),
      passRate: randomNum(1, 1)
    };
  },
  basic_main_question: function(index) {
    return {
      name: "题名称" + index,
      objective: true,
      fullScore: randomNum(20),
      maxScore: randomNum(20),
      minScore: randomNum(10),
      avgScore: randomNum(10),
      stdevScore: randomNum(5),
      coefficient: randomNum(10),
      difficulty: randomNum(1, 1),
      discrimination: randomNum(2),
      totalCount: randomNum(1000),
      zeroCount: randomNum(50),
      fullCount: randomNum(50)
    };
  },
  discrimination_level_question: function(index) {
    return {
      name: "大题名称" + index,
      questionCount: 50,
      fullScore: randomNum(150),
      coefficient: randomNum(10, 2),
      levels: {
        excellent: {
          questionCount: randomNum(10),
          fullScore: randomNum(50)
        },
        good: {
          questionCount: randomNum(40),
          fullScore: randomNum(50)
        },
        general: {
          questionCount: randomNum(30),
          fullScore: randomNum(20)
        },
        bad: {
          questionCount: randomNum(20),
          fullScore: randomNum(10)
        }
      }
    };
  },
  difficulty_level_question: function(index) {
    return {
      name: "大题名称" + index,
      questionCount: 50,
      fullScore: randomNum(150),
      difficulty: randomNum(10, 2),
      levels: {
        high: {
          questionCount: randomNum(10),
          fullScore: randomNum(50)
        },
        middle: {
          questionCount: randomNum(40),
          fullScore: randomNum(50)
        },
        low: {
          questionCount: randomNum(30),
          fullScore: randomNum(20)
        }
      }
    };
  },
  basic_question_option: function(index) {
    var optionsAns = {};
    options
      .filter(function() {
        return Math.random() > 0.5;
      })
      .map(function(key) {
        optionsAns[key] = randomNum(2000);
      });

    return {
      number: "题号" + index,
      totalCount: 10000,
      correctCount: randomNum(5000),
      difficulty: randomNum(1, 2),
      discrimination: randomNum(1, 2),
      answer: "C",
      options: optionsAns
    };
  },
  range_level: function(index) {
    return {
      name: "新媒体" + index,
      highScore: randomNum(90),
      lowScore: randomNum(90),
      totalCount: randomNum(10000)
    };
  },
  range_score_level: function(index, isStep) {
    return {
      score: isStep ? 150 - index * 10 : 100 - index,
      rangeCount: randomNum(10000),
      rangeRate: randomNum(30, 2),
      sumCount: randomNum(10000),
      sumRate: randomNum(100, 2)
    };
  }
};

var dataStatic = {
  subjectName: "英语",
  examName: "2019年6月期末考试",
  schoolName: "呼家楼中心小学",
  basic_question_objective: getNum(30).map(function(item, index) {
    return chartData.basic_question(index, true);
  }),
  basic_question_subjective: getNum(30).map(function(item, index) {
    return chartData.basic_question(index, false);
  }),
  basic_class: getNum(26).map(function(item, index) {
    return chartData.basic_class(index);
  }),
  basic_teacher: getNum(11).map(function(item, index) {
    var teacher = chartData.basic_teacher(index);
    teacher.classes = getNum(7).map(function(elem, eindex) {
      return chartData.basic_teacher_class(eindex);
    });
    return teacher;
  }),
  basic_college: getNum(26).map(function(item, index) {
    return chartData.basic_college(index);
  }),
  basic_main_question: getNum(6).map(function(item, index) {
    return chartData.basic_main_question(index);
  }),
  discrimination_level: getNum(8).map(function(item, index) {
    return {
      name: index == 0 ? "全部" : "传媒技术" + index + "班",
      groups: getNum(7).map(function(elem, eindex) {
        return chartData.discrimination_level_question(eindex);
      })
    };
  }),
  difficulty_level: getNum(8).map(function(item, index) {
    return {
      name: index == 0 ? "全部" : "传媒技术" + index + "班",
      groups: getNum(7).map(function(elem, eindex) {
        return chartData.difficulty_level_question(eindex);
      })
    };
  }),
  basic_question_option: {
    options: options.slice(0, -1),
    questions: getNum(78).map(function(elem, eindex) {
      return chartData.basic_question_option(eindex);
    })
  },
  range_level: getNum(35).map(function(item, index) {
    return chartData.range_level(index);
  }),
  range_10_totalScore: {
    total: getNum(16).map(function(elem, eindex) {
      return chartData.range_score_level(eindex, true);
    }),
    classes: getNum(5).map(function(item, index) {
      return {
        name: "新媒体" + index,
        ranges: getNum(16).map(function(elem, eindex) {
          return chartData.range_score_level(eindex, true);
        })
      };
    })
  },
  range_1_totalScore: {
    total: getNum(100).map(function(elem, eindex) {
      return chartData.range_score_level(eindex, false);
    }),
    classes: getNum(5).map(function(item, index) {
      return {
        name: "新媒体" + index,
        ranges: getNum(100).map(function(elem, eindex) {
          return chartData.range_score_level(eindex, false);
        })
      };
    })
  },
  range_segment_6: getNum(8).map(function(item, index) {
    return {
      name: "题目类型" + index,
      groups: getNum(7).map(function(elem, eindex) {
        return {
          name: eindex == 0 ? "全部" : "传媒技术" + index + "班",
          segments: getNum(7).map(function(seg, sindex) {
            return chartData.range_score_level(sindex, true);
          })
        };
      })
    };
  })
};
